/*
CVE Services API

The CVE Services API supports automation tooling for the CVE Program. Credentials are     required for most service endpoints. Representatives of     <a href='https://www.cve.org/ProgramOrganization/CNAs'>CVE Numbering Authorities (CNAs)</a> should     use one of the methods below to obtain credentials:    <ul><li>If your organization already has an Organizational Administrator (OA) account for the CVE     Services, ask your admin for credentials</li>     <li>Contact your Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/Google'>Google</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/INCIBE'>INCIBE</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/jpcert'>JPCERT/CC</a>, or     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/redhat'>Red Hat</a>) or     Top-Level Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/icscert'>CISA ICS</a>     or <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/mitre'>MITRE</a>) to request credentials     </ul>     <p>CVE data is to be in the JSON 5.0 CVE Record format. Details of the JSON 5.0 schema are     located <a href='https://github.com/CVEProject/cve-schema/tree/master/schema/v5.0' target='_blank'>here</a>.</p>    <a href='https://cveform.mitre.org/' class='link' target='_blank'>Contact the CVE Services team</a>

API version: 2.1.4
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package cveapi

import (
	"encoding/json"
)

// checks if the CreateFullCveRecordRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CreateFullCveRecordRequest{}

// CreateFullCveRecordRequest struct for CreateFullCveRecordRequest
type CreateFullCveRecordRequest struct {
	Containers *CreateFullCveRecordRequestContainers `json:"containers,omitempty"`
	CveMetadata *GetCveRecordResponseCveMetadata `json:"cveMetadata,omitempty"`
	DataType *string `json:"dataType,omitempty"`
	DateVersion *string `json:"dateVersion,omitempty"`
}

// NewCreateFullCveRecordRequest instantiates a new CreateFullCveRecordRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateFullCveRecordRequest() *CreateFullCveRecordRequest {
	this := CreateFullCveRecordRequest{}
	return &this
}

// NewCreateFullCveRecordRequestWithDefaults instantiates a new CreateFullCveRecordRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateFullCveRecordRequestWithDefaults() *CreateFullCveRecordRequest {
	this := CreateFullCveRecordRequest{}
	return &this
}

// GetContainers returns the Containers field value if set, zero value otherwise.
func (o *CreateFullCveRecordRequest) GetContainers() CreateFullCveRecordRequestContainers {
	if o == nil || IsNil(o.Containers) {
		var ret CreateFullCveRecordRequestContainers
		return ret
	}
	return *o.Containers
}

// GetContainersOk returns a tuple with the Containers field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateFullCveRecordRequest) GetContainersOk() (*CreateFullCveRecordRequestContainers, bool) {
	if o == nil || IsNil(o.Containers) {
		return nil, false
	}
	return o.Containers, true
}

// HasContainers returns a boolean if a field has been set.
func (o *CreateFullCveRecordRequest) HasContainers() bool {
	if o != nil && !IsNil(o.Containers) {
		return true
	}

	return false
}

// SetContainers gets a reference to the given CreateFullCveRecordRequestContainers and assigns it to the Containers field.
func (o *CreateFullCveRecordRequest) SetContainers(v CreateFullCveRecordRequestContainers) {
	o.Containers = &v
}

// GetCveMetadata returns the CveMetadata field value if set, zero value otherwise.
func (o *CreateFullCveRecordRequest) GetCveMetadata() GetCveRecordResponseCveMetadata {
	if o == nil || IsNil(o.CveMetadata) {
		var ret GetCveRecordResponseCveMetadata
		return ret
	}
	return *o.CveMetadata
}

// GetCveMetadataOk returns a tuple with the CveMetadata field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateFullCveRecordRequest) GetCveMetadataOk() (*GetCveRecordResponseCveMetadata, bool) {
	if o == nil || IsNil(o.CveMetadata) {
		return nil, false
	}
	return o.CveMetadata, true
}

// HasCveMetadata returns a boolean if a field has been set.
func (o *CreateFullCveRecordRequest) HasCveMetadata() bool {
	if o != nil && !IsNil(o.CveMetadata) {
		return true
	}

	return false
}

// SetCveMetadata gets a reference to the given GetCveRecordResponseCveMetadata and assigns it to the CveMetadata field.
func (o *CreateFullCveRecordRequest) SetCveMetadata(v GetCveRecordResponseCveMetadata) {
	o.CveMetadata = &v
}

// GetDataType returns the DataType field value if set, zero value otherwise.
func (o *CreateFullCveRecordRequest) GetDataType() string {
	if o == nil || IsNil(o.DataType) {
		var ret string
		return ret
	}
	return *o.DataType
}

// GetDataTypeOk returns a tuple with the DataType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateFullCveRecordRequest) GetDataTypeOk() (*string, bool) {
	if o == nil || IsNil(o.DataType) {
		return nil, false
	}
	return o.DataType, true
}

// HasDataType returns a boolean if a field has been set.
func (o *CreateFullCveRecordRequest) HasDataType() bool {
	if o != nil && !IsNil(o.DataType) {
		return true
	}

	return false
}

// SetDataType gets a reference to the given string and assigns it to the DataType field.
func (o *CreateFullCveRecordRequest) SetDataType(v string) {
	o.DataType = &v
}

// GetDateVersion returns the DateVersion field value if set, zero value otherwise.
func (o *CreateFullCveRecordRequest) GetDateVersion() string {
	if o == nil || IsNil(o.DateVersion) {
		var ret string
		return ret
	}
	return *o.DateVersion
}

// GetDateVersionOk returns a tuple with the DateVersion field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateFullCveRecordRequest) GetDateVersionOk() (*string, bool) {
	if o == nil || IsNil(o.DateVersion) {
		return nil, false
	}
	return o.DateVersion, true
}

// HasDateVersion returns a boolean if a field has been set.
func (o *CreateFullCveRecordRequest) HasDateVersion() bool {
	if o != nil && !IsNil(o.DateVersion) {
		return true
	}

	return false
}

// SetDateVersion gets a reference to the given string and assigns it to the DateVersion field.
func (o *CreateFullCveRecordRequest) SetDateVersion(v string) {
	o.DateVersion = &v
}

func (o CreateFullCveRecordRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CreateFullCveRecordRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Containers) {
		toSerialize["containers"] = o.Containers
	}
	if !IsNil(o.CveMetadata) {
		toSerialize["cveMetadata"] = o.CveMetadata
	}
	if !IsNil(o.DataType) {
		toSerialize["dataType"] = o.DataType
	}
	if !IsNil(o.DateVersion) {
		toSerialize["dateVersion"] = o.DateVersion
	}
	return toSerialize, nil
}

type NullableCreateFullCveRecordRequest struct {
	value *CreateFullCveRecordRequest
	isSet bool
}

func (v NullableCreateFullCveRecordRequest) Get() *CreateFullCveRecordRequest {
	return v.value
}

func (v *NullableCreateFullCveRecordRequest) Set(val *CreateFullCveRecordRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateFullCveRecordRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateFullCveRecordRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateFullCveRecordRequest(val *CreateFullCveRecordRequest) *NullableCreateFullCveRecordRequest {
	return &NullableCreateFullCveRecordRequest{value: val, isSet: true}
}

func (v NullableCreateFullCveRecordRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateFullCveRecordRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


